<?php

namespace Scalapay\Scalapay\Helper;
use \Magento\Framework\App\Helper\AbstractHelper;

class Data extends AbstractHelper
{
   protected $_productMetadataInterface;
   protected $_datetime;
   
   public function __construct(
        \Magento\Framework\App\ProductMetadataInterface $productMetadataInterface,
        \Magento\Framework\Stdlib\DateTime\DateTime $datetime
    ) {

        $this->_productMetadataInterface = $productMetadataInterface;
        $this->_datetime = $datetime;
    }
    
   public function log($log_string)
   {
        if (isset($log_string)) {
            $oldFileName = $this->getLogFileName("-2 months");

            if (file_exists($oldFileName)) {
                unlink($oldFileName);
            }

            $filename = $this->getLogFileName();  
            try {
                if (version_compare($this->_productMetadataInterface->getVersion(), '2.4.2', '<=')){
                    //version is 2.4.2 or below
                    $writer = new \Zend\Log\Writer\Stream($filename);
                    $logger = new \Zend\Log\Logger();
                    $logger->addWriter($writer);

                    if (!is_array($log_string) && !is_object($log_string)) {
                        $logger->info($log_string);
                    } else {
                        $logger->info(print_r($log_string, true));
                    }
                } 
                else {
                    //version is higher 2.4.2
                    $writer = new \Zend_Log_Writer_Stream($filename);
                    $logger = new \Zend_Log();
                    $logger->addWriter($writer);

                    if (!is_array($log_string) && !is_object($log_string)) {
                        $logger->info($log_string);
                    } else {
                        $logger->info(print_r($log_string, true));
                    }
                }
            } catch (\Exception $e) {
                $e->getMessage();
            }
                      
        }
    }

    public function getLogFileName($fileDate = "")
    {
        $basePath = \Magento\Framework\App\Filesystem\DirectoryList::getDefaultConfig();

        $filename = "";
        $logDir = BP."/".$basePath['log']['path'];
        
        if (isset($fileDate) && $fileDate!=="") {
            $filename = $logDir . '/scalapay_'.$this->_datetime->date('Y_m', $fileDate).'.log';
        } else {
            $filename = $logDir . '/scalapay_'.$this->_datetime->date('Y_m').'.log';
        }
        
        return $filename;
    }
}
